<template>
  <div class="navitem" :class="{ navitemactive: isactive }" @click="onnav">
    <Inprototype v-if="inprotp"/>
    <div class="nav-item-indicator"></div>
    <div class="iconandlabel">
      <Icon :icon="icon" color="C-737278" />
      <p>{{ label }}</p>
    </div>
    <div class="nav-item-count" v-if="count">
      {{ count }}
    </div>
    <div class="nav-chevron" v-if="isexpandable">
      <Icon icon='chevron-down' color="C-89888D" />
    </div>
  </div>
</template>

<script setup>
import { useMainStore } from '~~/stores/main';
import { storeToRefs } from 'pinia';
import { computed, ref } from 'vue'

const main = useMainStore();
const { section, url } = storeToRefs(main);
const { onNavigate } = main;

const props = defineProps({
  icon: {
    type: String,
    required: false,
    default: "abuse"
  },
  label: {
    type: String,
    required: false,
    default: "Nav Item"
  },
  navurl: {
    type: String,
    required: false,
    default: "#"
  },
  isactive: {
    type: Boolean,
    required: false,
    default: false
  },
  isexpandable: {
    type: Boolean,
    required: false,
    default: false
  },
  user: {
    type: Object,
    required: false,
    default: {}
  },
});

const usr = ref(props.user)

const count = computed({
  get () {
    let n = null
    switch (props.label) {
      case "Issues":
        if (section.value.id === 'yourwork') {
          n = usr.value.issues
        } else {
          n = Math.floor(Math.random() * 99);
        }
        break;
      case "Merge requests":
        if (section.value.id === 'yourwork') {
          n = usr.value.mergerequests
        } else {
          n = Math.floor(Math.random() * 99);
        }
        break;
      case "To-Do List":
        if (section.value.id === 'yourwork') {
          n = usr.value.todo
        } else {
          n = Math.floor(Math.random() * 99);
        }
        break;
      default:
        n = null
        break;
    }
    return n
  }
})

const isactive = computed({
  get () {
    let test = false;
    if (props.label.includes('overview') && url.value.includes('overview')){
      test = true
    }else if ( `${section.value.org}-${section.value.id}-${props.navurl}` === url.value ) {
      test = true
    }
    return test
  }
})

const inprotp = computed({
  get () {
    let test = false;
    if (props.navurl){
      test = true
    }
    return test
  }
})

function onnav() {
  let dest = {
    url: ""
  }
  if (props.navurl) {
    dest.url = `${section.value.org}-${section.value.id}-${props.navurl}`;
  }
  onNavigate(dest);
}
</script>

<style>
.navitem {
  display: flex;
  align-items: center;
  justify-content: left;
  height: 32px;
  font-size: 14px;
  line-height: 16px;
  color: #333238;
  padding: 0 0 0 12px;
  border-radius: 4px;
}

.navitem:hover {
  background-color: #ECECEF;
}

.navitemactive {
  background-color: #ECECEF;
}

.nav-item-indicator {
  background-color: none;
  width: 3px;
  height: 24px;
  border-radius: 4px;
  margin: 0 4px 0 0;
}

.navitemactive .nav-item-indicator {
  background-color: #1F75CB;
}

.iconandlabel {
  display: flex;
  flex-grow: 1;
  align-items: center;
  justify-content: left;
  gap: 8px;
  text-align: left;
}

.nav-item-count {
  height: 16px;
  padding: 0 8px 0 8px;
  margin: 0 8px 0 4px;
  color: #0b5cad;
  background-color: #cbe2f9;
  border-radius: 160px;
  font-size: 12px;
}

.nav-chevron {
  padding: 0 8px 0 4px;
}
</style>
